(* Copyright (c) 2003 Michal Moskal <malekith@pld-linux.org>
   Licensed under the Academic Free License version 2.0 *)
let process_macros name =
  let define_macro () line =
    if My_String.strip line = "" then ()
    else
      match line.[0] with
      | '#' -> ()
      | '%' -> 
        let (name, value) = 
          My_String.first_word (My_String.chop_prefix 1 line)
        in
        Macro.add_macro name (My_String.strip value)
      | _ -> Generic_parser.err "ill-formed macro line"
  in
  try
    Unix.access name [Unix.F_OK];
    Generic_parser.in_context
      (fun () -> Generic_parser.fold_logical_lines define_macro ())
      name
  with Unix.Unix_error _ -> ()

let process_all_macro_files () =
  process_macros "/usr/lib/rpm/macros";
  process_macros ("/usr/lib/rpm/" ^ !Flags.target ^ "/macros");
  process_macros "/etc/rpm/macros";
  process_macros (Unix.getenv "HOME" ^ "/.rpmmacros")

